	-------------------------------------------------------------
	-- WRITE.E                         Irv Mullins                   irv@ellijay.com --
	-------------------------------------------------------------
  -- Derived from code by Matthew McNamara (_mat@iconz.co.nz)
  -- Many thanks!

  -- procedure write(sequence)
     -- Prints sequences & sequences within sequences,
     -- handles mixed strings and numbers with aplomb,
     -- like Pascal, but better!

  -- procedure writeln(sequence)
     -- As above, with added \n at the end of the line
	------------------------------------------------------------
include Rstrings.e
  -- uses function String() to determine if obj is a striny

global constant
	FG = 7,  		--graphics.e.WHITE
	BG = 0,     --graphics.e.BLACK
	HIGH = 14   --graphics.e.YELLOW

procedure blarg(atom handle, object x)
 if atom(x) then
    puts(handle, sprintf("%d ", x))
 else if String(x) then
	 puts(handle, x)
	 puts(handle," ")
      else for i = 1 to length(x) do
	       blarg(handle, x[i]) -- recurse
	   end for
      end if --String(x)
  end if -- atom(x)
end procedure

global procedure Writexy(sequence s)
    if length(s) = 1 then puts(1,s[1])
    elsif length(s) = 2 then
       position(s[1][2],s[1][1])
       puts(1,s[2])
    end if
end procedure

global procedure Write(object x)
  blarg(1, x)
end procedure

global procedure Writeln(object x)
  blarg(1,x)
  puts(1,"\n")
end procedure

global procedure WriteAtt(object Str, integer Attr)
	text_color(Attr)
	Write(Str)
	text_color(FG)
end procedure --WriteAtt

global procedure WritelnAtt(object Str, integer Attr)
	text_color(Attr)
	Writeln(Str)
	text_color(FG)
end procedure --WritelnAtt

global procedure WriteHi(object Str)
	WriteAtt(Str,HIGH)
end procedure --WriteHi

global procedure WritelnHi(object Str)
	WritelnAtt(Str,HIGH)
end procedure --WritelnHi
